benchkit
========

Super simple benchmarking framework for Java.

 * Good for when you want to get going quick
 * … or when Caliper is overkill
 * … or if you want to have multiple threads in play
 * … or just really like latency histograms

Installation
------------

Benchkit is easily install with Maven using a command similar to this:

    mvn clean install -DperformRelease=true

The HdrHistogram library that benchkit depends on is shaded into the installed
.jar, so you don't have to worry about getting that into your repositories as
well.

To install a new version of HdrHistogram into the lib-folder repository, copy
the .jar file into this directory (the project root) and install it with a
command similar to this one, but of course specifying the relevant version:

    mvn install:install-file \
      -DgroupId=com.github.giltene \
      -DartifactId=HdrHistogram \
      -Dpackaging=jar \
      -DlocalRepositoryPath=lib \
      -Dfile=HdrHistogram.jar \
      -Dversion=ed271fd737d927930b5651f7fc697a2bf963a606

The version here is referring to the specific git commit SHA. Don't forget to
also update the `pom.xml` file, so that it refers to the newly installed
library.

Quick Note on Caliper
---------------------

Caliper is really, really good at micro benchmarks, and measuring tiny, tiny
pieces of code. Benchkit isn't really good at that, and generally prefer
benchmarks that have a bit more meat on their bones. Specifically, Benchkit is
good when there is variability in the latency of what is being measured.
