package org.benchkit;

import org.HdrHistogram.Histogram;

/**
 * An object that represents the recorded results of a benchmark session, or
 * whatever the {@link Recorder} was recording.
 * @author cvh
 *
 */
public class RecordingData {
  private String benchmarkName;
  private long elapsedRuntimeMillis;
  private long totalRecordings;
  private Histogram data;
  private double datapointConversionFactor;
  private long min;
  private long max;

  public RecordingData(
      String benchmarkName,
      long elapsedRuntimeMillis,
      long totalRecordings,
      Histogram data,
      double datapointConversionFactor,
      long min,
      long max) {
    this.benchmarkName = benchmarkName;
    this.elapsedRuntimeMillis = elapsedRuntimeMillis;
    this.totalRecordings = totalRecordings;
    this.data = data;
    this.datapointConversionFactor = datapointConversionFactor;
    this.min = min;
    this.max = max;
  }

  public long getElapsedRuntimeMillis() {
    return elapsedRuntimeMillis;
  }

  public long getTotalRecordings() {
    return totalRecordings;
  }

  public Histogram getHisogram() {
    return data;
  }

  public double getDatapointConversionFactor() {
    return datapointConversionFactor;
  }
  
  public String getBenchmarkName() {
    return benchmarkName;
  }
  
  public long getMinRecordedValue() {
    return min;
  }
  
  public long getMaxRecordedValue() {
    return max;
  }
}
