package org.benchkit.htmlchartsreporter;

public class Hsl {

  private final int hue;
  private final int saturation;
  private final int lightness;

  public Hsl(int hue, int saturation, int lightness) {
    this.hue = hue;
    this.saturation = saturation;
    this.lightness = lightness;
  }
  
  @Override
  public String toString() {
    return toCssHsl();
  }

  public String toCssHsl() {
    return String.format("hsl(%s, %s%%, %s%%)", hue, saturation, lightness);
  }

  public String toCssHsla(double alpha) {
    return String.format("hsla(%s, %s%%, %s%%, %1.3f)", hue, saturation, lightness, alpha);
  }
}
