package org.benchkit.htmlchartsreporter;

import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

public class JsonOut {
  public static String json(Object obj) {
    StringBuilder sb = new StringBuilder();
    json(obj, sb);
    return sb.toString();
  }

  public static void json(Object obj, StringBuilder sb) {
    if (obj instanceof Map) {
      jsonMap((Map<?, ?>) obj, sb);
    } else if (obj instanceof Collection) {
      jsonColl((Collection<?>) obj, sb);
    } else if (obj instanceof String) {
      sb.append('"');
      // ugh... a world of escaping bugs are hiding here...
      sb.append(obj.toString());
      sb.append('"');
    } else {
      sb.append(obj);
    }
  }

  private static void jsonColl(Collection<?> obj, StringBuilder sb) {
    Iterator<?> itr = obj.iterator();
    if (!itr.hasNext()) {
      sb.append("[]");
    } else {
      sb.append('[');
      json(itr.next(), sb);
      while (itr.hasNext()) {
        sb.append(',');
        json(itr.next(), sb);
      }
      sb.append(']');
    }
  }

  private static <K,V> void jsonMap(Map<K, V> obj, StringBuilder sb) {
    Iterator<Entry<K, V>> itr = obj.entrySet().iterator();
    if (!itr.hasNext()) {
      sb.append("{}");
    } else {
      sb.append('{');
      jsonEntry(itr.next(), sb);
      while (itr.hasNext()) {
        sb.append(',');
        jsonEntry(itr.next(), sb);
      }
      sb.append('}');
    }
  }
  
  private static void jsonEntry(Entry<?, ?> entry, StringBuilder sb) {
    sb.append(entry.getKey());
    sb.append(':');
    json(entry.getValue(), sb);
  }
}
